/* GRID */

* { box-sizing: border-box; }

html {
  font-family: sans-serif;
  font-size: 16px;
  margin: 0;
  padding: 0;
}

body {

}

.monotype {
  font-family: monospace;
  background-color: khaki;
  padding: 4px 8px;
  border-radius: 4px;
}

.grid-container {
  background-color: grey;
  display: block;
  margin-bottom: 40px;
  padding: 5px;

  background-color: #f7f7f7;
  border-radius: 3px;
  padding: 20px;
}

  .grid-item {
    font-size: 20px;
    text-align: center;
    border-radius: 4px;
    background-color: #A2CBFA;
    border: 1px solid #4390E1;
    box-sizing: border-box;
    box-shadow: 0 2px 2px rgba(0,90,250,0.05), 0 4px 4px rgba(0,90,250,0.05), 0 8px 8px rgba(0,90,250,0.05), 0 16px 16px rgba(0,90,250,0.05);
  }


/* CONTENEDOR GRID */

/* 1. display:grid */

.grid-container {
  display: inline-grid;
}


/* 2. grid-template-columns / grid-template-rows */

.grid-template-colrows {
  width: 600px;
  height: 400px;

  /* grid-template-columns: [first] 40px [line2] 50px [line3] auto [col4-start] 50px [five] 40px [end];
  grid-template-rows: [row1-start] 25% [row1-end] 100px [third-line] auto [last-line]; */

  /* grid-template-columns: repeat(3, 180px [col-start]);
  grid-template-columns: 180px [col-start] 180px [col-start] 180px [col-start]; */

  grid-template-columns: 1fr 50px 2fr;

}


/* 3. grid-template-areas */

.grid-template-areas {
  height: 200px;

  grid-template-columns: repeat(4, 100px);
  grid-template-rows: auto;
  grid-template-areas: 
    "header header header header"
    "main main . sidebar"
    "footer footer footer footer";
}

.gta-header { grid-area: header; }
.gta-main { grid-area: main; }
.gta-sidebar { grid-area: sidebar; }
.gta-footer { grid-area: footer; }


/* 4. grid-template */

.grid-template {
  width: 600px;

  grid-template:
    "header header header header" auto
    "main main . sidebar" auto
    "footer footer footer footer" auto
    / 100px 100px 100px 100px;
}

.grid-template .gta-header { grid-area: header; }
.grid-template .gta-main { grid-area: main; }
.grid-template .gta-sidebar { grid-area: sidebar; }
.grid-template .gta-footer { grid-area: footer; }


/* 5. grid-column—gap / grid-row—gap */

.grid-colrow—gap {
  grid-template-columns: 100px 50px 100px;
  grid-template-rows: 80px auto 80px;

  grid-column-gap: 10px;
  grid-row-gap: 20px;

  width: 310px;
}


/* 6. grid-gap */

.grid-gap {
  grid-template-columns: 100px 50px 100px;
  grid-template-rows: 80px auto 80px;

  grid-gap: 20px 10px;

  width: 310px;
}


/* 7. justify-items */

.justify-items {
  grid-template-columns: 100px 100px 100px;
  grid-template-rows: 60px 60px 60px;

  justify-items: stretch;
  justify-items: start;
  justify-items: end;
  justify-items: center;
}

  .justify-items .grid-item { min-width: 60px; }


/* 8. align-items */

.align-items {
  grid-template-columns: 60px 60px 60px;
  grid-template-rows: 100px 100px 100px; 

  align-items: stretch;
  align-items: start;
  align-items: end;
  align-items: center;
}

  .align-items .grid-item { min-height: 60px; }


/* 9. place-items */

.place-items {
  grid-template-columns: 100px 100px 100px;
  grid-template-rows: 100px 100px 100px;

  place-items: start end;
  place-items: end end;
  place-items: end center;
}

  .place-items .grid-item {
    min-width: 60px;
    min-height: 60px;
  }


/* 10. justify-content */

.justify-content {
  grid-template-columns: 100px auto 100px;
  grid-template-rows: 100px auto 100px;

  justify-content: stretch;
  justify-content: start;
  justify-content: end;
  justify-content: center;
  justify-content: space-around;
  justify-content: space-between;
  justify-content: space-evenly;

  width: 600px;
}

  .justify-content .grid-item {
    min-width: 60px;
    min-height: 60px;
  }


/* 11. align-content */

.align-content {
  grid-template-columns: 100px auto 100px;
  grid-template-rows: 100px auto 100px;

  align-content: stretch;
  align-content: start;
  align-content: end;
  align-content: center;
  align-content: space-around;
  align-content: space-between;
  align-content: space-evenly;

  height: 600px;
}

  .align-content .grid-item {
    min-width: 60px;
    min-height: 60px;
  }


/* 12. place-content */

.place-content {
  grid-template-columns: 100px auto 100px;
  grid-template-rows: 100px auto 100px;

  place-content: start end;
  place-content: start space-between;
  place-content: center stretch;
  place-content: stretch center;
  place-content: space-between space-between;
  place-content: space-evenly space-evenly;

  width: 600px;
  height: 600px;
}

  .place-content .grid-item {
    min-width: 60px;
    min-height: 60px;
  }


/* 13. grid-auto-columns / grid-auto-rows */

.grid-auto-colrows {
  grid-template-columns: 60px 60px;
  grid-template-rows: 90px 90px;

  grid-auto-columns: 60px;

  width: 600px;
}

  .grid-auto-colrows .grid-item {
    min-width: 60px;
    min-height: 60px;
  }

  .grid-auto-colrows .elemento-a {
    grid-column: 1/2;
    grid-row: 2/3;
    
  }
  .grid-auto-colrows .elemento-b {
    grid-column: 5/6;
    grid-row: 2/3;
  }


/* 14. grid-auto-flow */

.grid-auto-flow {
  grid-template-columns: 120px 120px 120px 120px 120px;
  grid-template-rows: 60px 60px;

  grid-auto-flow: row;
  grid-auto-flow: column;
}

  .grid-auto-flow .grid-item {
    
  }

  .grid-auto-flow .elemento-a {
    grid-column: 1;
    grid-row: 1/3;
  }
  .grid-auto-flow .elemento-c {
    grid-column: 5;
    grid-row: 1/3;
  }


/* 15. grid */

.grid {
  width: 600px;
  height: 600px;

  grid: 100px 300px / 3fr 1fr;
}

.grid-complex {
  width: 600px;
  height: 600px;

  grid: "header header header header" auto
    "main main . sidebar" auto
    "footer footer footer footer" auto
    / 100px 100px 100px 100px;
}



/* ELEMENTOS GRID */

/* 1. grid-column-start / grid-row-start / grid-column-end / grid-row-end */

.grid-colrow-startend {
  grid-template-columns: [first] 40px [line2] 50px [line3] 100px [col4-start] 50px [five] 40px [end];
  grid-template-rows: [row1-start] 60px [row1-end] 100px [third-line] 100px [last-line];
}


.grid-colrow-startend .elemento-a {
  grid-column-start: 2;
  grid-column-end: five;
  grid-row-start: row1-start;
  grid-row-end: 3;
}

.grid-colrow-startend .elemento-b {
  grid-column-start: 1;
  grid-column-end: span col4-start;
  grid-row-start: 2;
  grid-row-end: span 2;
}


/* 2. grid-column / grid-row */

.grid-colrow {
  grid-template-columns: [first] 40px [line2] 50px [line3] 100px [col4-start] 50px [five] 40px [end];
  grid-template-rows: [row1-start] 60px [row1-end] 100px [third-line] 100px [last-line];
}

  .grid-colrow .elemento-a {
    grid-column: 3 / span 2;
    grid-row: 3 / 4;
  }


/* 3. grid-area */

.grid-area {
  grid-template-columns: [first] 40px [line2] 50px [line3] 100px [col4-start] 50px [five] 40px [end];
  grid-template-rows: [row1-start] 60px [row1-end] 100px [third-line] 100px [last-line];
  grid-template-areas: 
    "header header header sidebar sidebar"
    "main main . sidebar sidebar"
    "footer footer footer sidebar sidebar";
}

  .grid-area .elemento-a {
    /* grid-area: 1 / 4 / span 3 / span 2; */
    grid-area: sidebar;
  }


/* 4. justify-self */

.justify-self {
  grid-template-columns: [first] 40px [line2] 50px [line3] 100px [col4-start] 50px [five] 40px [end];
  grid-template-rows: [row1-start] 60px [row1-end] 100px [third-line] 100px [last-line];
}

  .justify-self .elemento-a {
    justify-self: stretch;
    justify-self: start;
    justify-self: end;
    justify-self: center;
  }


/* 5. align-self */

.align-self {
  grid-template-columns: [first] 40px [line2] 50px [line3] 100px [col4-start] 50px [five] 40px [end];
  grid-template-rows: [row1-start] 60px [row1-end] 100px [third-line] 100px [last-line];
}

  .align-self .elemento-a {
    align-self: stretch;
    align-self: start;
    align-self: end;
    align-self: center;
  }


/* 6. place-self */

.place-self {
  grid-template-columns: [first] 40px [line2] 50px [line3] 100px [col4-start] 50px [five] 40px [end];
  grid-template-rows: [row1-start] 60px [row1-end] 100px [third-line] 100px [last-line];

  place-items: start end;
}

  .place-self .elemento-a {
    place-self: center;
    place-self: end center;
  }

